package com.palmergames;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;
import javax.swing.text.DefaultCaret;
import javax.swing.JTextField;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.DataInputStream;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.OutputStreamWriter;
import java.util.Scanner;

public class HenryUI {

	private JFrame frame;
	private static Mypirc HenryBot;
	static JTextArea textArea;
	private JTextField textField;
	private static String config = "config.txt";

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {

		EventQueue.invokeLater(new Runnable() {

			public void run() {

				try {
					HenryUI window = new HenryUI();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
					return;
				}

				// Setup our IRC
				HenryBot = new Mypirc("towny-help");

				try {
					HenryBot.start(null);

					System.out.print("Attempting to LOAD the brain!!!");

					// Try to load a previously saved brain.
					if (!loadBrain()) {
						// No brain, so add a base entry.
						System.out.print("Creating a fresh new brain!!!");
						
						String messages[] = { "I'm quite lonely.",
								"If you need help just ask your question (and end it with a question mark).",
								"You can download the release and dev builds of Towny at http://palmergames.com/downloads",
								"You can download the latest GroupManager from http://palmergames.com/downloads",
								"To file a suggestion use this ( http://goo.gl/YJAEv )",
								"To file an issue ticket use this ( http://goo.gl/FDqSZ )",
								"You will need Register or Vault if you use any economy besides iConomy 5.01",
								"For Towny to hook and use economy plugins you will need either Register or Vault."
								};

						for (String msg : messages)
							if (HenryBot.getHal().add(msg))
								saveSentence(msg);

					}

				} catch (Exception e) {
					// Failed to start IRC.
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public HenryUI() {

		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {

		frame = new JFrame();
		frame.addWindowListener(new WindowAdapter() {

			@Override
			public void windowClosing(WindowEvent e) {

				System.out.print("Attempting to save brain!!!");

			}
		});
		frame.setResizable(false);
		frame.setBounds(100, 100, 654, 544);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(null);

		// Vertical scroll controls for the chat log area
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(10, 11, 628, 456);
		scrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		scrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		frame.getContentPane().add(scrollPane);

		// Chat logging area.
		textArea = new JTextArea();
		textArea.setLineWrap(true);
		textArea.setBounds(0, 0, 483, 456);
		scrollPane.setViewportView(textArea);
		textArea.setEditable(false);

		// Text entry edit box
		textField = new JTextField();
		textField.setBounds(10, 478, 628, 20);
		frame.getContentPane().add(textField);
		textField.setColumns(10);

		textField.addActionListener(new ActionListener() {

			/**
			 * Relay all text entered into the edit box to the current channel.
			 */
			public void actionPerformed(ActionEvent e) {

				String message = textField.getText();
				HenryBot.sendMessage(HenryBot.getChannel(), message);
				textField.setText("");

				textArea.append("Henry: " + message + System.getProperty("line.separator"));

				// Also teach this sentence to Hal.
				if (HenryBot.getHal().add(message))
					HenryUI.saveSentence(message);
			}
		});

		// Set the chat log to auto scroll to the bottom
		DefaultCaret caret = (DefaultCaret) textArea.getCaret();
		caret.setUpdatePolicy(DefaultCaret.ALWAYS_UPDATE);

	}

	/**
	 * Add a sentence to the dictionary.
	 * 
	 * @param sentence
	 */
	public static void saveSentence(String sentence) {

		File file = new File(config);

		//if (file.exists() && file.isFile() && file.canWrite()) {

		FileWriter fstream = null;
		BufferedWriter out = null;

			try {
				fstream = new FileWriter(file,true);
				out = new BufferedWriter(fstream);

				out.write(sentence + System.getProperty("line.separator"));

			} catch (Exception e) {
				System.out.println("Exception Adding sentence to File!!!");
			} finally {
				try {
					out.close();
					fstream.close();
				} catch (Exception ex) {
				}
			}
		//}

	}

	public static boolean loadBrain() {

		boolean loaded = false;

		File file = new File(config);

		if (file.exists() && file.isFile() && file.canRead() && file.length() > 0) {

			//FileInputStream fileInputStream = null;

			Scanner lines = null;
			try {
				lines = new Scanner(file);
				
				while (lines.hasNext()) {
					HenryBot.getHal().add(lines.nextLine());
					loaded = true;
				}
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} finally {
				lines.close();
			}	

		}
		return loaded;
	}
}
